-- 8-bit Shift and Compare

library ieee;
use ieee.std_logic_1164.all;

entity ShiftAndCompare is port ( Clk, Rst, Load: in std_ulogic;
                                 Init: in std_ulogic_vector ( 7 downto 0 );
                                 Test: in std_ulogic_vector ( 7 downto 0 );
                                 Limit: out std_ulogic );
end ShiftAndCompare;

architecture ShiftAndCompare_1 of ShiftAndCompare is

   component Comparator
      port ( A, B: in std_ulogic_vector ( 7 downto 0 );
             EQ: out std_ulogic );
   end component;

   component ShiftRegister
      port ( Clk, Rst, Load: in std_ulogic;
             Data: in std_ulogic_vector ( 7 downto 0 );
             Q: out std_ulogic_vector ( 7 downto 0 ) );
   end component;

   signal Q: std_ulogic_vector ( 7 downto 0 );

begin

   COMP1:  Comparator port map ( A => Q, B => Test, EQ => Limit );
   SHFT1:  ShiftRegister port map ( Clk => Clk, Rst => Rst, Load =>
                                    Load, Data => Init, Q => Q );

end ShiftAndCompare_1;
