-- 8-bit shift register
-- version 1: Process Statement

library ieee;
use ieee.std_logic_1164.all;

entity ShiftRegister is
   port ( Clk, Rst, Load: in std_ulogic;
          Data: in std_ulogic_vector ( 7 downto 0 );
          Q: out std_ulogic_vector ( 7 downto 0 ) );
end ShiftRegister;

architecture ShiftRegister_1 of ShiftRegister is

   signal Qreg: std_ulogic_vector ( 7 downto 0 );

begin

   reg: process ( Rst, Clk )
   begin
      if Rst = '1' then                              -- Asyncronous reset
         Qreg <= "00000000";
      elsif ( Clk = '1' and Clk'event ) then
         if ( Load = '1' ) then
            Qreg <= Data;
         else
            Qreg <= Qreg ( 6 downto 0 ) & Qreg ( 7 );
         end if;
      end if;
   end process;
   Q <= Qreg;

end ShiftRegister_1;
